﻿// 1. Создает артбоарды по контуру каждого прилинкованного файла 
//  https://forum.rudtp.ru/resources/adobe-illustrator-skript-sozdaet-artbordy-po-razmeram-vydelennyx-obektov.3161/

// 2. Переименовывает артбоард по имени прилинкованного файла 
//  https://community.adobe.com/t5/illustrator-discussions/auto-rename-artboards-based-on-placed-image-filename/m-p/11493355#M247455


//###############################################################################################

#target illustrator
if (app.documents.length !== 0) {
	var doc = app.activeDocument;  
	if (doc.selection.length > 0) {
		if (doc.selection.length < 100) {
			remove_artboards_afore();
			make_artboards_for_selection(); 
			doc.artboards.getByName("delete").remove();
		}	else {
			alert ("Выделено более 100 объектов, миссия провалена :(")
			};
	}	else {
		alert ("Нет выделенных объектов, миссия провалена :(")
		};
}	else {
	alert('Нет открытых документов');
	};

function remove_artboards_afore(){
	if (doc.artboards.length > 1) {
		for (var i = doc.artboards.length -1; i > 0; i--) {
			doc.artboards[i].remove();
		};
	};
	doc.artboards[0].name = "delete"
};

function make_artboards_for_selection(){  
	var gb = new Array();
	for ( var i =0; i < doc.selection.length; i++ ){
		gb[i] = doc.selection[i].geometricBounds;
		doc.artboards.add (gb[i]);
		//redraw();
	};
};

//###############################################################################################

#target illustrator
function test(){
	var doc = app.activeDocument;
	var boards = doc.artboards;
	var thisBoard, artItemOnBoard, placedItemName;
	for (var i = 0; i < boards.length; i++) {
		thisBoard = boards[i];
		doc.artboards.setActiveArtboardIndex(i);
		doc.selection = null;
		doc.selectObjectsOnActiveArtboard();
		for (var j = 0; j < doc.selection.length; j++) {
			artItemOnBoard = doc.selection[j];
			if (artItemOnBoard.typename == "PlacedItem") {
				placedItemName = decodeURI(artItemOnBoard.file.name).replace(/\.[^\.]+$/, "");
				thisBoard.name = placedItemName;
			}
		}
	}
}
test();

//###############################################################################################